commit:     94265238b8319c896bd6c2806fea8da139d07eca
Author:     Felix Janda <felix.janda <AT> posteo <DOT> de>
AuthorDate: Sat Jan 17 18:56:40 2015 +0000
Commit:     Anthony G. Basile <blueness <AT> gentoo <DOT> org>
CommitDate: Sat Jan 17 19:40:24 2015 +0000
URL:        
http://sources.gentoo.org/gitweb/?p=proj/hardened-dev.git;a=commit;h=94265238

media-libs/mesa: bump to 10.2.8

---
 media-libs/mesa/files/mesa-10-pthread.patch        |  24 +
 .../mesa-10.2-dont-require-llvm-for-r300.patch     |  11 +
 .../files/mesa-10.2-sysfs-instead-of-libudev.patch | 378 +++++++++++++++
 media-libs/mesa/mesa-10.2.8-r99.ebuild             | 537 +++++++++++++++++++++
 4 files changed, 950 insertions(+)

diff --git a/media-libs/mesa/files/mesa-10-pthread.patch 
b/media-libs/mesa/files/mesa-10-pthread.patch
new file mode 100644
index 0000000..17a8bda
--- /dev/null
+++ b/media-libs/mesa/files/mesa-10-pthread.patch
@@ -0,0 +1,24 @@
+mesa-10.patch from sabotage linux
+
+--- ./include/c11/threads_posix.h.orig
++++ ./include/c11/threads_posix.h
+@@ -178,7 +178,7 @@
+         return thrd_error;
+     pthread_mutexattr_init(&attr);
+     if ((type & mtx_recursive) != 0) {
+-#if defined(__linux__) || defined(__linux)
++#if defined(__GLIBC__)
+         pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_RECURSIVE_NP);
+ #else
+         pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_RECURSIVE);
+--- ./src/gallium/winsys/svga/drm/vmw_screen.h.orig
++++ ./src/gallium/winsys/svga/drm/vmw_screen.h
+@@ -34,7 +34,7 @@
+ #ifndef VMW_SCREEN_H_
+ #define VMW_SCREEN_H_
+ 
+-
++#include <sys/stat.h>
+ #include "pipe/p_compiler.h"
+ #include "pipe/p_state.h"
+ 

diff --git a/media-libs/mesa/files/mesa-10.2-dont-require-llvm-for-r300.patch 
b/media-libs/mesa/files/mesa-10.2-dont-require-llvm-for-r300.patch
new file mode 100644
index 0000000..a85a3c1
--- /dev/null
+++ b/media-libs/mesa/files/mesa-10.2-dont-require-llvm-for-r300.patch
@@ -0,0 +1,11 @@
+diff -Naur a/configure.ac b/configure.ac
+--- a/configure.ac     2014-03-03 04:05:33.110522943 +0100
++++ b/configure.ac     2014-03-03 04:06:44.165518094 +0100
+@@ -1774,7 +1774,6 @@
+             HAVE_GALLIUM_R300=yes
+             PKG_CHECK_MODULES([RADEON], [libdrm_radeon >= 
$LIBDRM_RADEON_REQUIRED])
+             gallium_require_drm_loader
+-            gallium_require_llvm "Gallium R300"
+             GALLIUM_DRIVERS_DIRS="$GALLIUM_DRIVERS_DIRS r300"
+             gallium_check_st "radeon/drm" "r300/dri" "" "" ""
+             DRICOMMON_NEED_LIBDRM=yes

diff --git a/media-libs/mesa/files/mesa-10.2-sysfs-instead-of-libudev.patch 
b/media-libs/mesa/files/mesa-10.2-sysfs-instead-of-libudev.patch
new file mode 100644
index 0000000..6eed6ac
--- /dev/null
+++ b/media-libs/mesa/files/mesa-10.2-sysfs-instead-of-libudev.patch
@@ -0,0 +1,378 @@
+From 85b6f36ca5238dd3fec7c5fcacb8b7074ce53c8e Mon Sep 17 00:00:00 2001
+From: Gary Wong <g...@gnu.org>
+Date: Wed, 21 May 2014 21:07:42 -0600
+Subject: loader: add optional /sys filesystem method for PCI identification.
+
+Introduce a simple PCI identification method of looking up the answer
+the /sys filesystem (available on Linux).  Attempted after libudev, but
+before DRM.
+
+Disabled by default (available only when the --enable-sysfs configure
+option is specified).
+
+Signed-off-by: Gary Wong <g...@gnu.org>
+Acked-by: Emil Velikov <emil.l.veli...@gmail.com>
+
+Backported to mesa-10.2.8 by Ian Stakenvicius <a...@gentoo.org>
+
+--- a/configure.ac
++++ b/configure.ac
+@@ -870,14 +870,21 @@ fi
+ 
+ case "$host_os" in
+ linux*)
+-    need_libudev=yes ;;
++    need_pci_id=yes ;;
+ *)
+-    need_libudev=no ;;
++    need_pci_id=no ;;
+ esac
+ 
+ PKG_CHECK_MODULES([LIBUDEV], [libudev >= $LIBUDEV_REQUIRED],
+                   have_libudev=yes, have_libudev=no)
+ 
++AC_ARG_ENABLE([sysfs],
++    [AS_HELP_STRING([--enable-sysfs],
++        [enable /sys PCI identification @<:@default=disabled@:>@])],
++    [have_sysfs="$enableval"],
++    [have_sysfs=no]
++)
++
+ if test "x$enable_dri" = xyes; then
+     if test "$enable_static" = yes; then
+         AC_MSG_ERROR([Cannot use static libraries for DRI drivers])
+@@ -973,8 +980,15 @@ xyesno)
+     ;;
+ esac
+ 
++have_pci_id=no
+ if test "$have_libudev" = yes; then
+     DEFINES="$DEFINES -DHAVE_LIBUDEV"
++    have_pci_id=yes
++fi
++
++if test "$have_sysfs" = yes; then
++    DEFINES="$DEFINES -DHAVE_SYSFS"
++    have_pci_id=yes
+ fi
+ 
+ # This is outside the case (above) so that it is invoked even for non-GLX
+@@ -1076,8 +1090,8 @@ if test "x$enable_dri" = xyes; then
+             DEFINES="$DEFINES -DHAVE_DRI3"
+         fi
+ 
+-        if test "x$have_libudev" != xyes; then
+-            AC_MSG_ERROR([libudev-dev required for building DRI])
++        if test "x$have_pci_id" != xyes; then
++            AC_MSG_ERROR([libudev-dev or sysfs required for building DRI])
+         fi
+ 
+         case "$host_cpu" in
+@@ -1252,8 +1266,8 @@ if test "x$enable_gbm" = xauto; then
+     esac
+ fi
+ if test "x$enable_gbm" = xyes; then
+-    if test "x$need_libudev$have_libudev" = xyesno; then
+-        AC_MSG_ERROR([gbm requires udev >= $LIBUDEV_REQUIRED])
++    if test "x$need_pci_id$have_pci_id" = xyesno; then
++        AC_MSG_ERROR([gbm requires udev >= $LIBUDEV_REQUIRED or sysfs])
+     fi
+ 
+     if test "x$enable_dri" = xyes; then
+@@ -1271,7 +1285,7 @@ if test "x$enable_gbm" = xyes; then
+     fi
+ fi
+ AM_CONDITIONAL(HAVE_GBM, test "x$enable_gbm" = xyes)
+-if test "x$need_libudev" = xyes; then
++if test "x$need_pci_id$have_libudev" = xyesyes; then
+     GBM_PC_REQ_PRIV="libudev >= $LIBUDEV_REQUIRED"
+ else
+     GBM_PC_REQ_PRIV=""
+@@ -1560,9 +1574,9 @@ for plat in $egl_platforms; do
+               ;;
+       esac
+ 
+-        case "$plat$need_libudev$have_libudev" in
++        case "$plat$need_pci_id$have_pci_id" in
+                 waylandyesno|drmyesno)
+-                    AC_MSG_ERROR([cannot build $plat platform without udev >= 
$LIBUDEV_REQUIRED]) ;;
++                    AC_MSG_ERROR([cannot build $plat platform without udev >= 
$LIBUDEV_REQUIRED or sysfs]) ;;
+         esac
+ done
+ 
+@@ -1843,8 +1857,8 @@ gallium_require_llvm() {
+ 
+ gallium_require_drm_loader() {
+     if test "x$enable_gallium_loader" = xyes; then
+-        if test "x$need_libudev$have_libudev" = xyesno; then
+-            AC_MSG_ERROR([Gallium drm loader requires libudev >= 
$LIBUDEV_REQUIRED])
++        if test "x$need_pci_id$have_pci_id" = xyesno; then
++            AC_MSG_ERROR([Gallium drm loader requires libudev >= 
$LIBUDEV_REQUIRED or sysfs])
+         fi
+         if test "x$have_libdrm" != xyes; then
+             AC_MSG_ERROR([Gallium drm loader requires libdrm >= 
$LIBDRM_REQUIRED])
+--- a/src/loader/loader.c      2014-09-19 13:03:22.000000000 -0400
++++ b/src/loader/loader.c      2014-11-25 12:46:51.412249717 -0500
+@@ -71,6 +71,10 @@
+ #include <assert.h>
+ #include <dlfcn.h>
+ #endif
++#ifdef HAVE_SYSFS
++#include <sys/stat.h>
++#include <sys/types.h>
++#endif
+ #include "loader.h"
+ 
+ #ifndef __NOT_HAVE_DRM_H
+@@ -113,8 +117,8 @@
+          udev_handle = dlopen("libudev.so.0", RTLD_LOCAL | RTLD_LAZY);
+ 
+          if (!udev_handle) {
+-            log_(_LOADER_FATAL, "Couldn't dlopen libudev.so.1 or 
libudev.so.0, "
+-                 "driver detection may be broken.\n");
++            log_(_LOADER_WARNING, "Couldn't dlopen libudev.so.1 or "
++                 "libudev.so.0, driver detection may be broken.\n");
+          }
+       }
+    }
+@@ -122,16 +126,19 @@
+    return udev_handle;
+ }
+ 
++static int dlsym_failed = 0;
++
+ static void *
+-asserted_dlsym(void *dlopen_handle, const char *name)
++checked_dlsym(void *dlopen_handle, const char *name)
+ {
+    void *result = dlsym(dlopen_handle, name);
+-   assert(result);
++   if (!result)
++      dlsym_failed = 1;
+    return result;
+ }
+ 
+ #define UDEV_SYMBOL(ret, name, args) \
+-   ret (*name) args = asserted_dlsym(udev_dlopen_handle(), #name);
++   ret (*name) args = checked_dlsym(udev_dlopen_handle(), #name);
+ 
+ 
+ static inline struct udev_device *
+@@ -142,6 +149,9 @@
+    UDEV_SYMBOL(struct udev_device *, udev_device_new_from_devnum,
+                (struct udev *udev, char type, dev_t devnum));
+ 
++   if (dlsym_failed)
++      return NULL;
++
+    if (fstat(fd, &buf) < 0) {
+       log_(_LOADER_WARNING, "MESA-LOADER: failed to stat fd %d\n", fd);
+       return NULL;
+@@ -157,8 +167,8 @@
+    return device;
+ }
+ 
+-int
+-loader_get_pci_id_for_fd(int fd, int *vendor_id, int *chip_id)
++static int
++libudev_get_pci_id_for_fd(int fd, int *vendor_id, int *chip_id)
+ {
+    struct udev *udev = NULL;
+    struct udev_device *device = NULL, *parent;
+@@ -174,6 +184,9 @@
+ 
+    *chip_id = -1;
+ 
++   if (dlsym_failed)
++      return 0;
++
+    udev = udev_new();
+    device = udev_device_new_from_fd(udev, fd);
+    if (!device)
+@@ -201,16 +214,76 @@
+ 
+    return (*chip_id >= 0);
+ }
++#endif
++
++#if defined(HAVE_SYSFS)
++static int
++dev_node_from_fd(int fd, unsigned int *maj, unsigned int *min)
++{
++   struct stat buf;
++
++   if (fstat(fd, &buf) < 0) {
++      log_(_LOADER_WARNING, "MESA-LOADER: failed to stat fd %d\n", fd);
++      return -1;
++   }
++
++   if (!S_ISCHR(buf.st_mode)) {
++      log_(_LOADER_WARNING, "MESA-LOADER: fd %d not a character device\n", 
fd);
++      return -1;
++   }
++
++   *maj = major(buf.st_rdev);
++   *min = minor(buf.st_rdev);
++
++   return 0;
++}
++
++static int
++sysfs_get_pci_id_for_fd(int fd, int *vendor_id, int *chip_id)
++{
++   unsigned int maj, min;
++   FILE *f;
++   char buf[0x40];
+ 
+-#elif !defined(__NOT_HAVE_DRM_H)
++   if (dev_node_from_fd(fd, &maj, &min) < 0) {
++      *chip_id = -1;
++      return 0;
++   }
+ 
++   snprintf(buf, sizeof(buf), "/sys/dev/char/%d:%d/device/vendor", maj, min);
++   if (!(f = fopen(buf, "r"))) {
++      *chip_id = -1;
++      return 0;
++   }
++   if (fscanf(f, "%x", vendor_id) != 1) {
++      *chip_id = -1;
++      fclose(f);
++      return 0;
++   }
++   fclose(f);
++   snprintf(buf, sizeof(buf), "/sys/dev/char/%d:%d/device/device", maj, min);
++   if (!(f = fopen(buf, "r"))) {
++      *chip_id = -1;
++      return 0;
++   }
++   if (fscanf(f, "%x", chip_id) != 1) {
++      *chip_id = -1;
++      fclose(f);
++      return 0;
++   }
++   fclose(f);
++   return 1;
++}
++#endif
++
++#if !defined(__NOT_HAVE_DRM_H)
+ /* for i915 */
+ #include <i915_drm.h>
+ /* for radeon */
+ #include <radeon_drm.h>
+ 
+-int
+-loader_get_pci_id_for_fd(int fd, int *vendor_id, int *chip_id)
++static int
++drm_get_pci_id_for_fd(int fd, int *vendor_id, int *chip_id)
+ {
+    drmVersionPtr version;
+ 
+@@ -272,23 +345,33 @@
+ 
+    return (*chip_id >= 0);
+ }
++#endif
+ 
+-#else
+ 
+ int
+ loader_get_pci_id_for_fd(int fd, int *vendor_id, int *chip_id)
+ {
++#if HAVE_LIBUDEV
++   if (libudev_get_pci_id_for_fd(fd, vendor_id, chip_id))
++      return 1;
++#endif
++#if HAVE_SYSFS
++   if (sysfs_get_pci_id_for_fd(fd, vendor_id, chip_id))
++      return 1;
++#endif
++#if !defined(__NOT_HAVE_DRM_H)
++   if (drm_get_pci_id_for_fd(fd, vendor_id, chip_id))
++      return 1;
++#endif
+    return 0;
+ }
+ 
+-#endif
+-
+ 
+-char *
+-loader_get_device_name_for_fd(int fd)
++#ifdef HAVE_LIBUDEV
++static char *
++libudev_get_device_name_for_fd(int fd)
+ {
+    char *device_name = NULL;
+-#ifdef HAVE_LIBUDEV
+    struct udev *udev;
+    struct udev_device *device;
+    const char *const_device_name;
+@@ -312,9 +395,66 @@
+ out:
+    udev_device_unref(device);
+    udev_unref(udev);
++   return device_name;
++}
+ #endif
++
++
++#if HAVE_SYSFS
++static char *
++sysfs_get_device_name_for_fd(int fd)
++{
++   char *device_name = NULL;
++   unsigned int maj, min;
++   FILE *f;
++   char buf[0x40];
++   static const char match[9] = "\0DEVNAME=";
++   int expected = 1;
++
++   if (dev_node_from_fd(fd, &maj, &min) < 0)
++      return NULL;
++
++   snprintf(buf, sizeof(buf), "/sys/dev/char/%d:%d/uevent", maj, min);
++   if (!(f = fopen(buf, "r")))
++       return NULL;
++
++   while (expected < sizeof(match)) {
++      int c = getc(f);
++
++      if (c == EOF) {
++         fclose(f);
++         return NULL;
++      } else if (c == match[expected] )
++         expected++;
++      else
++         expected = 0;
++   }
++
++   strcpy(buf, "/dev/");
++   if (fgets(buf + 5, sizeof(buf) - 5, f))
++      device_name = strdup(buf);
++
++   fclose(f);
+    return device_name;
+ }
++#endif
++
++
++char *
++loader_get_device_name_for_fd(int fd)
++{
++   char *result = NULL;
++
++#if HAVE_LIBUDEV
++   if ((result = libudev_get_device_name_for_fd(fd)))
++      return result;
++#endif
++#if HAVE_SYSFS
++   if ((result = sysfs_get_device_name_for_fd(fd)))
++      return result;
++#endif
++   return result;
++}
+ 
+ char *
+ loader_get_driver_for_fd(int fd, unsigned driver_types)

diff --git a/media-libs/mesa/mesa-10.2.8-r99.ebuild 
b/media-libs/mesa/mesa-10.2.8-r99.ebuild
new file mode 100644
index 0000000..e78b2a6
--- /dev/null
+++ b/media-libs/mesa/mesa-10.2.8-r99.ebuild
@@ -0,0 +1,537 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/media-libs/mesa/mesa-10.2.8.ebuild,v 1.10 
2015/01/09 20:53:31 klausman Exp $
+
+EAPI=5
+
+EGIT_REPO_URI="git://anongit.freedesktop.org/mesa/mesa"
+
+if [[ ${PV} = 9999* ]]; then
+       GIT_ECLASS="git-r3"
+       EXPERIMENTAL="true"
+fi
+
+PYTHON_COMPAT=( python{2_6,2_7} )
+
+inherit base autotools multilib multilib-minimal flag-o-matic \
+       python-any-r1 toolchain-funcs pax-utils ${GIT_ECLASS}
+
+OPENGL_DIR="xorg-x11"
+
+MY_PN="${PN/m/M}"
+MY_P="${MY_PN}-${PV/_/-}"
+MY_SRC_P="${MY_PN}Lib-${PV/_/-}"
+
+FOLDER="${PV/.0_rc*/}"
+
+DESCRIPTION="OpenGL-like graphic library for Linux"
+HOMEPAGE="http://mesa3d.sourceforge.net/";
+
+#SRC_PATCHES="mirror://gentoo/${P}-gentoo-patches-01.tar.bz2"
+if [[ $PV = 9999* ]]; then
+       SRC_URI="${SRC_PATCHES}"
+else
+       
SRC_URI="ftp://ftp.freedesktop.org/pub/mesa/${FOLDER}/${MY_SRC_P}.tar.bz2
+               ${SRC_PATCHES}"
+fi
+
+# The code is MIT/X11.
+# GLES[2]/gl[2]{,ext,platform}.h are SGI-B-2.0
+LICENSE="MIT SGI-B-2.0"
+SLOT="0"
+KEYWORDS="amd64 arm ~mips ppc x86"
+
+INTEL_CARDS="i915 i965 ilo intel"
+RADEON_CARDS="r100 r200 r300 r600 radeon radeonsi"
+VIDEO_CARDS="${INTEL_CARDS} ${RADEON_CARDS} freedreno nouveau vmware"
+for card in ${VIDEO_CARDS}; do
+       IUSE_VIDEO_CARDS+=" video_cards_${card}"
+done
+
+IUSE="${IUSE_VIDEO_CARDS}
+       bindist +classic debug +dri3 +egl +gallium +gbm gles1 gles2 +llvm +nptl
+       opencl openvg osmesa pax_kernel openmax pic r600-llvm-compiler selinux
+       +udev vdpau wayland xvmc xa kernel_FreeBSD kernel_linux"
+
+REQUIRED_USE="
+       llvm?   ( gallium )
+       openvg? ( egl gallium )
+       opencl? (
+               gallium
+               video_cards_r600? ( r600-llvm-compiler )
+               video_cards_radeon? ( r600-llvm-compiler )
+               video_cards_radeonsi? ( r600-llvm-compiler )
+       )
+       openmax? ( gallium )
+       gles1?  ( egl )
+       gles2?  ( egl )
+       r600-llvm-compiler? ( gallium llvm || ( video_cards_r600 
video_cards_radeonsi video_cards_radeon ) )
+       wayland? ( egl gbm )
+       xa?  ( gallium )
+       video_cards_freedreno?  ( gallium )
+       video_cards_intel?  ( || ( classic gallium ) )
+       video_cards_i915?   ( || ( classic gallium ) )
+       video_cards_i965?   ( classic )
+       video_cards_ilo?    ( gallium )
+       video_cards_nouveau? ( || ( classic gallium ) )
+       video_cards_radeon? ( || ( classic gallium ) )
+       video_cards_r100?   ( classic )
+       video_cards_r200?   ( classic )
+       video_cards_r300?   ( gallium )
+       video_cards_r600?   ( gallium )
+       video_cards_radeonsi?   ( gallium llvm )
+       video_cards_vmware? ( gallium )
+       ${PYTHON_REQUIRED_USE}
+"
+
+LIBDRM_DEPSTRING=">=x11-libs/libdrm-2.4.54"
+# keep correct libdrm and dri2proto dep
+# keep blocks in rdepend for binpkg
+RDEPEND="
+       !<x11-base/xorg-server-1.7
+       !<=x11-proto/xf86driproto-2.0.3
+       abi_x86_32? ( !app-emulation/emul-linux-x86-opengl[-abi_x86_32(-)] )
+       classic? ( app-admin/eselect-mesa )
+       gallium? ( app-admin/eselect-mesa )
+       >=app-admin/eselect-opengl-1.2.7
+       udev? ( kernel_linux? ( >=virtual/libudev-215:=[${MULTILIB_USEDEP}] ) )
+       >=dev-libs/expat-2.1.0-r3:=[${MULTILIB_USEDEP}]
+       >=x11-libs/libX11-1.6.2:=[${MULTILIB_USEDEP}]
+       >=x11-libs/libxshmfence-1.1:=[${MULTILIB_USEDEP}]
+       >=x11-libs/libXdamage-1.1.4-r1:=[${MULTILIB_USEDEP}]
+       >=x11-libs/libXext-1.3.2:=[${MULTILIB_USEDEP}]
+       >=x11-libs/libXxf86vm-1.1.3:=[${MULTILIB_USEDEP}]
+       >=x11-libs/libxcb-1.9.3:=[${MULTILIB_USEDEP}]
+       llvm? (
+               video_cards_radeonsi? ( || (
+                       >=dev-libs/elfutils-0.155-r1:=[${MULTILIB_USEDEP}]
+                       >=dev-libs/libelf-0.8.13-r2:=[${MULTILIB_USEDEP}]
+                       ) )
+               video_cards_r600? ( || (
+                       >=dev-libs/elfutils-0.155-r1:=[${MULTILIB_USEDEP}]
+                       >=dev-libs/libelf-0.8.13-r2:=[${MULTILIB_USEDEP}]
+                       ) )
+               !video_cards_r600? (
+                       video_cards_radeon? ( || (
+                               
>=dev-libs/elfutils-0.155-r1:=[${MULTILIB_USEDEP}]
+                               
>=dev-libs/libelf-0.8.13-r2:=[${MULTILIB_USEDEP}]
+                               ) )
+               )
+               >=sys-devel/llvm-3.3-r3:=[${MULTILIB_USEDEP}]
+       )
+       opencl? (
+                               app-admin/eselect-opencl
+                               dev-libs/libclc
+                       )
+       openmax? ( >=media-libs/libomxil-bellagio-0.9.3:=[${MULTILIB_USEDEP}] )
+       vdpau? ( >=x11-libs/libvdpau-0.7:=[${MULTILIB_USEDEP}] )
+       wayland? ( >=dev-libs/wayland-1.2.0:=[${MULTILIB_USEDEP}] )
+       xvmc? ( >=x11-libs/libXvMC-1.0.8:=[${MULTILIB_USEDEP}] )
+       
${LIBDRM_DEPSTRING}[video_cards_freedreno?,video_cards_nouveau?,video_cards_vmware?,${MULTILIB_USEDEP}]
+"
+for card in ${INTEL_CARDS}; do
+       RDEPEND="${RDEPEND}
+               video_cards_${card}? ( ${LIBDRM_DEPSTRING}[video_cards_intel] )
+       "
+done
+
+for card in ${RADEON_CARDS}; do
+       RDEPEND="${RDEPEND}
+               video_cards_${card}? ( ${LIBDRM_DEPSTRING}[video_cards_radeon] )
+       "
+done
+
+DEPEND="${RDEPEND}
+       ${PYTHON_DEPS}
+       llvm? (
+               r600-llvm-compiler? ( sys-devel/llvm[video_cards_radeon] )
+               video_cards_radeonsi? ( sys-devel/llvm[video_cards_radeon] )
+       )
+       opencl? (
+                               >=sys-devel/llvm-3.3-r3:=[${MULTILIB_USEDEP}]
+                               >=sys-devel/clang-3.3:=[${MULTILIB_USEDEP}]
+                               >=sys-devel/gcc-4.6
+       )
+       sys-devel/bison
+       sys-devel/flex
+       sys-devel/gettext
+       virtual/pkgconfig
+       >=x11-proto/dri2proto-2.8-r1:=[${MULTILIB_USEDEP}]
+       dri3? (
+               >=x11-proto/dri3proto-1.0:=[${MULTILIB_USEDEP}]
+               >=x11-proto/presentproto-1.0:=[${MULTILIB_USEDEP}]
+       )
+       >=x11-proto/glproto-1.4.16-r1:=[${MULTILIB_USEDEP}]
+       >=x11-proto/xextproto-7.2.1-r1:=[${MULTILIB_USEDEP}]
+       >=x11-proto/xf86driproto-2.1.1-r1:=[${MULTILIB_USEDEP}]
+       >=x11-proto/xf86vidmodeproto-2.3.1-r1:=[${MULTILIB_USEDEP}]
+"
+
+S="${WORKDIR}/${MY_P}"
+EGIT_CHECKOUT_DIR=${S}
+
+# It is slow without texrels, if someone wants slow
+# mesa without texrels +pic use is worth the shot
+QA_EXECSTACK="usr/lib*/opengl/xorg-x11/lib/libGL.so*"
+QA_WX_LOAD="usr/lib*/opengl/xorg-x11/lib/libGL.so*"
+
+# Think about: ggi, fbcon, no-X configs
+
+pkg_setup() {
+       # workaround toc-issue wrt #386545
+       use ppc64 && append-flags -mminimal-toc
+
+       # warning message for bug 459306
+       if use llvm && has_version sys-devel/llvm[!debug=]; then
+               ewarn "Mismatch between debug USE flags in media-libs/mesa and 
sys-devel/llvm"
+               ewarn "detected! This can cause problems. For details, see bug 
459306."
+       fi
+
+       python-any-r1_pkg_setup
+}
+
+src_unpack() {
+       default
+       [[ $PV = 9999* ]] && git-r3_src_unpack
+}
+
+src_prepare() {
+       # apply patches
+       if [[ ${PV} != 9999* && -n ${SRC_PATCHES} ]]; then
+               EPATCH_FORCE="yes" \
+               EPATCH_SOURCE="${WORKDIR}/patches" \
+               EPATCH_SUFFIX="patch" \
+               epatch
+       fi
+
+       # relax the requirement that r300 must have llvm, bug 380303
+       epatch "${FILESDIR}"/${PN}-10.2-dont-require-llvm-for-r300.patch
+
+       # allow sysfs to serve pci ids instead of libudev
+       epatch "${FILESDIR}"/${PN}-10.2-sysfs-instead-of-libudev.patch
+
+       # musl fixes
+       epatch "${FILESDIR}"/${PN}-9.1.6-fpclassify.patch
+       epatch "${FILESDIR}"/${PN}-10-pthread.patch
+
+       # fix for hardened pax_kernel, bug 240956
+       [[ ${PV} != 9999* ]] && epatch "${FILESDIR}"/glx_ro_text_segm.patch
+
+       # Solaris needs some recent POSIX stuff in our case
+       if [[ ${CHOST} == *-solaris* ]] ; then
+               sed -i -e "s/-DSVR4/-D_POSIX_C_SOURCE=200112L/" configure.ac || 
die
+       fi
+
+       base_src_prepare
+
+       eautoreconf
+       multilib_copy_sources
+}
+
+multilib_src_configure() {
+       local myconf
+
+       if use classic; then
+       # Configurable DRI drivers
+               driver_enable swrast
+
+       # Intel code
+               driver_enable video_cards_i915 i915
+               driver_enable video_cards_i965 i965
+               if ! use video_cards_i915 && \
+                       ! use video_cards_i965; then
+                       driver_enable video_cards_intel i915 i965
+               fi
+
+               # Nouveau code
+               driver_enable video_cards_nouveau nouveau
+
+               # ATI code
+               driver_enable video_cards_r100 radeon
+               driver_enable video_cards_r200 r200
+               if ! use video_cards_r100 && \
+                               ! use video_cards_r200; then
+                       driver_enable video_cards_radeon radeon r200
+               fi
+       fi
+
+       if use egl; then
+               myconf+="--with-egl-platforms=x11$(use wayland && echo 
",wayland")$(use gbm && echo ",drm") "
+       fi
+
+       if use gallium; then
+               myconf+="
+                       $(use_enable llvm gallium-llvm)
+                       $(use_enable openvg)
+                       $(use_enable openvg gallium-egl)
+                       $(use_enable openmax omx)
+                       $(use_enable r600-llvm-compiler)
+                       $(use_enable vdpau)
+                       $(use_enable xa)
+                       $(use_enable xvmc)
+               "
+               gallium_enable swrast
+               gallium_enable video_cards_vmware svga
+               gallium_enable video_cards_nouveau nouveau
+               gallium_enable video_cards_i915 i915
+               gallium_enable video_cards_ilo ilo
+               if ! use video_cards_i915 && \
+                       ! use video_cards_i965; then
+                       gallium_enable video_cards_intel i915
+               fi
+
+               gallium_enable video_cards_r300 r300
+               gallium_enable video_cards_r600 r600
+               gallium_enable video_cards_radeonsi radeonsi
+               if ! use video_cards_r300 && \
+                               ! use video_cards_r600; then
+                       gallium_enable video_cards_radeon r300 r600
+               fi
+
+               gallium_enable video_cards_freedreno freedreno
+               # opencl stuff
+               if use opencl; then
+                       myconf+="
+                               $(use_enable opencl)
+                               
--with-opencl-libdir="${EPREFIX}/usr/$(get_libdir)/OpenCL/vendors/mesa"
+                               --with-clang-libdir="${EPREFIX}/usr/lib"
+                               "
+               fi
+       fi
+
+       # x86 hardened pax_kernel needs glx-rts, bug 240956
+       if use pax_kernel; then
+               myconf+="
+                       $(use_enable x86 glx-rts)
+               "
+       fi
+
+       # on abi_x86_32 hardened we need to have asm disable  
+       if [[ ${ABI} == x86* ]] && use pic; then
+               myconf+=" --disable-asm"
+       fi
+
+       # build fails with BSD indent, bug #428112
+       use userland_GNU || export INDENT=cat
+
+       econf \
+               --enable-dri \
+               --enable-glx \
+               --enable-shared-glapi \
+               $(use_enable !bindist texture-float) \
+               $(use_enable debug) \
+               $(use_enable dri3) \
+               $(use_enable egl) \
+               $(use_enable gbm) \
+               $(use_enable gles1) \
+               $(use_enable gles2) \
+               $(use_enable nptl glx-tls) \
+               $(use_enable osmesa) \
+               $(use_enable !udev sysfs) \
+               --enable-llvm-shared-libs \
+               --with-dri-drivers=${DRI_DRIVERS} \
+               --with-gallium-drivers=${GALLIUM_DRIVERS} \
+               PYTHON2="${PYTHON}" \
+               ${myconf}
+}
+
+multilib_src_install() {
+       emake install DESTDIR="${D}"
+
+       # Move libGL and others from /usr/lib to /usr/lib/opengl/blah/lib
+       # because user can eselect desired GL provider.
+       ebegin "Moving libGL and friends for dynamic switching"
+               local x
+               local gl_dir="/usr/$(get_libdir)/opengl/${OPENGL_DIR}/"
+               dodir ${gl_dir}/{lib,extensions,include/GL}
+               for x in 
"${ED}"/usr/$(get_libdir)/lib{EGL,GL*,OpenVG}.{la,a,so*}; do
+                       if [ -f ${x} -o -L ${x} ]; then
+                               mv -f "${x}" "${ED}${gl_dir}"/lib \
+                                       || die "Failed to move ${x}"
+                       fi
+               done
+               for x in "${ED}"/usr/include/GL/{gl.h,glx.h,glext.h,glxext.h}; 
do
+                       if [ -f ${x} -o -L ${x} ]; then
+                               mv -f "${x}" "${ED}${gl_dir}"/include/GL \
+                                       || die "Failed to move ${x}"
+                       fi
+               done
+               for x in "${ED}"/usr/include/{EGL,GLES*,VG,KHR}; do
+                       if [ -d ${x} ]; then
+                               mv -f "${x}" "${ED}${gl_dir}"/include \
+                                       || die "Failed to move ${x}"
+                       fi
+               done
+       eend $?
+
+       if use classic || use gallium; then
+                       ebegin "Moving DRI/Gallium drivers for dynamic 
switching"
+                       local gallium_drivers=( i915_dri.so i965_dri.so 
r300_dri.so r600_dri.so swrast_dri.so )
+                       keepdir /usr/$(get_libdir)/dri
+                       dodir /usr/$(get_libdir)/mesa
+                       for x in ${gallium_drivers[@]}; do
+                               if [ -f "$(get_libdir)/gallium/${x}" ]; then
+                                       mv -f 
"${ED}/usr/$(get_libdir)/dri/${x}" 
"${ED}/usr/$(get_libdir)/dri/${x/_dri.so/g_dri.so}" \
+                                               || die "Failed to move ${x}"
+                               fi
+                       done
+                       if use classic; then
+                               emake -C "${BUILD_DIR}/src/mesa/drivers/dri" 
DESTDIR="${D}" install
+                       fi
+                       for x in "${ED}"/usr/$(get_libdir)/dri/*.so; do
+                               if [ -f ${x} -o -L ${x} ]; then
+                                       mv -f "${x}" "${x/dri/mesa}" \
+                                               || die "Failed to move ${x}"
+                               fi
+                       done
+                       pushd "${ED}"/usr/$(get_libdir)/dri || die "pushd 
failed"
+                       ln -s ../mesa/*.so . || die "Creating symlink failed"
+                       # remove symlinks to drivers known to eselect
+                       for x in ${gallium_drivers[@]}; do
+                               if [ -f ${x} -o -L ${x} ]; then
+                                       rm "${x}" || die "Failed to remove ${x}"
+                               fi
+                       done
+                       popd
+               eend $?
+       fi
+       if use opencl; then
+               ebegin "Moving Gallium/Clover OpenCL implementation for dynamic 
switching"
+               local cl_dir="/usr/$(get_libdir)/OpenCL/vendors/mesa"
+               dodir ${cl_dir}/{lib,include}
+               if [ -f "${ED}/usr/$(get_libdir)/libOpenCL.so" ]; then
+                       mv -f "${ED}"/usr/$(get_libdir)/libOpenCL.so* \
+                       "${ED}"${cl_dir}
+               fi
+               if [ -f "${ED}/usr/include/CL/opencl.h" ]; then
+                       mv -f "${ED}"/usr/include/CL \
+                       "${ED}"${cl_dir}/include
+               fi
+               eend $?
+       fi
+
+       if use openmax; then
+               echo "XDG_DATA_DIRS=\"${EPREFIX}/usr/share/mesa/xdg\"" > 
"${T}/99mesaxdgomx"
+               doenvd "${T}"/99mesaxdgomx
+               keepdir /usr/share/mesa/xdg
+       fi
+}
+
+multilib_src_install_all() {
+       prune_libtool_files --all
+       einstalldocs
+
+       if use !bindist; then
+               dodoc docs/patents.txt
+       fi
+
+       # Install config file for eselect mesa
+       insinto /usr/share/mesa
+       newins "${FILESDIR}/eselect-mesa.conf.9.2" eselect-mesa.conf
+}
+
+multilib_src_test() {
+       if use llvm; then
+               local llvm_tests='lp_test_arit lp_test_arit lp_test_blend 
lp_test_blend lp_test_conv lp_test_conv lp_test_format lp_test_format 
lp_test_printf lp_test_printf'
+               pushd src/gallium/drivers/llvmpipe >/dev/null || die
+               emake ${llvm_tests}
+               pax-mark m ${llvm_tests}
+               popd >/dev/null || die
+       fi
+       emake check
+}
+
+pkg_postinst() {
+       # Switch to the xorg implementation.
+       echo
+       eselect opengl set --use-old ${OPENGL_DIR}
+
+       # switch to xorg-x11 and back if necessary, bug #374647 comment 11
+       OLD_IMPLEM="$(eselect opengl show)"
+       if [[ ${OPENGL_DIR}x != ${OLD_IMPLEM}x ]]; then
+               eselect opengl set ${OPENGL_DIR}
+               eselect opengl set ${OLD_IMPLEM}
+       fi
+
+       # Select classic/gallium drivers
+       if use classic || use gallium; then
+               eselect mesa set --auto
+       fi
+
+       # Switch to mesa opencl
+       if use opencl; then
+               eselect opencl set --use-old ${PN}
+       fi
+
+       # run omxregister-bellagio to make the OpenMAX drivers known system-wide
+       if use openmax; then
+               ebegin "Registering OpenMAX drivers"
+               
BELLAGIO_SEARCH_PATH="${EPREFIX}/usr/$(get_libdir)/libomxil-bellagio0" \
+                       
OMX_BELLAGIO_REGISTRY=${EPREFIX}/usr/share/mesa/xdg/.omxregister \
+                       omxregister-bellagio
+               eend $?
+       fi
+
+       # warn about patent encumbered texture-float
+       if use !bindist; then
+               elog "USE=\"bindist\" was not set. Potentially patent 
encumbered code was"
+               elog "enabled. Please see patents.txt for an explanation."
+       fi
+
+       local using_radeon r_flag
+       for r_flag in ${RADEON_CARDS}; do
+               if use video_cards_${r_flag}; then
+                       using_radeon=1
+                       break
+               fi
+       done
+
+       if [[ ${using_radeon} = 1 ]] && ! has_version media-libs/libtxc_dxtn; 
then
+               elog "Note that in order to have full S3TC support, it is 
necessary to install"
+               elog "media-libs/libtxc_dxtn as well. This may be necessary to 
get nice"
+               elog "textures in some apps, and some others even require this 
to run."
+       fi
+}
+
+pkg_prerm() {
+       if use openmax; then
+               rm "${EPREFIX}"/usr/share/mesa/xdg/.omxregister
+       fi
+}
+
+# $1 - VIDEO_CARDS flag
+# other args - names of DRI drivers to enable
+# TODO: avoid code duplication for a more elegant implementation
+driver_enable() {
+       case $# in
+               # for enabling unconditionally
+               1)
+                       DRI_DRIVERS+=",$1"
+                       ;;
+               *)
+                       if use $1; then
+                               shift
+                               for i in $@; do
+                                       DRI_DRIVERS+=",${i}"
+                               done
+                       fi
+                       ;;
+       esac
+}
+
+gallium_enable() {
+       case $# in
+               # for enabling unconditionally
+               1)
+                       GALLIUM_DRIVERS+=",$1"
+                       ;;
+               *)
+                       if use $1; then
+                               shift
+                               for i in $@; do
+                                       GALLIUM_DRIVERS+=",${i}"
+                               done
+                       fi
+                       ;;
+       esac
+}

Reply via email to